# settings_gui.cpp File Reference

GUI for settings. More...

`#include "stdafx.h"`
`#include "currency.h"`
`#include "gui.h"`
`#include "textbuf_gui.h"`
`#include "command_func.h"`
`#include "screenshot.h"`
`#include "network/network.h"`
`#include "town.h"`
`#include "settings_internal.h"`
`#include "newgrf_townname.h"`
`#include "strings_func.h"`
`#include "window_func.h"`
`#include "string_func.h"`
`#include "widgets/dropdown_type.h"`
`#include "widgets/dropdown_func.h"`
`#include "openttd.h"`
`#include "highscore.h"`
`#include "base_media_base.h"`
`#include "company_base.h"`
`#include "company_func.h"`
`#include "viewport_func.h"`
`#include "core/geometry_func.hpp"`
`#include "ai/ai.hpp"`
`#include <map>`
`#include "table/sprites.h"`
`#include "table/strings.h"`

Go to the source code of this file.

## Data Structures
struct | GameOptionsWindow
class | GameDifficultyWindow
struct | SettingEntrySubtree
| Data fields for a sub-page (SEF_SUBTREE_KIND kind). More...
struct | SettingEntrySetting
| Data fields for a single setting (SEF_SETTING_KIND kind). More...
struct | SettingEntry
| Data structure describing a single setting in a tab. More...
struct | SettingsPage
| Data structure describing one page of settings in the settings window. More...
struct | GameSettingsWindow
struct | CustomCurrencyWindow
## Enumerations
enum | GameOptionsWidgets { GOW_BACKGROUND, GOW_CURRENCY_DROPDOWN, GOW_DISTANCE_DROPDOWN, GOW_ROADSIDE_DROPDOWN, GOW_TOWNNAME_DROPDOWN, GOW_AUTOSAVE_DROPDOWN, GOW_LANG_DROPDOWN, GOW_RESOLUTION_DROPDOWN, GOW_FULLSCREEN_BUTTON, GOW_SCREENSHOT_DROPDOWN, GOW_BASE_GRF_DROPDOWN, GOW_BASE_GRF_STATUS, GOW_BASE_GRF_DESCRIPTION, GOW_BASE_SFX_DROPDOWN, GOW_BASE_SFX_DESCRIPTION, GOW_BASE_MUSIC_DROPDOWN, GOW_BASE_MUSIC_STATUS, GOW_BASE_MUSIC_DESCRIPTION }
| Widgets of the game options menu. More...
enum | GameDifficultyWidgets { GDW_LVL_EASY, GDW_LVL_MEDIUM, GDW_LVL_HARD, GDW_LVL_CUSTOM, GDW_HIGHSCORE, GDW_ACCEPT, GDW_CANCEL, GDW_OPTIONS_START }
enum | SettingEntryFlags { SEF_LEFT_DEPRESSED = 0x01, SEF_RIGHT_DEPRESSED = 0x02, SEF_BUTTONS_MASK = (SEF_LEFT_DEPRESSED | SEF_RIGHT_DEPRESSED), SEF_LAST_FIELD = 0x04, SEF_SETTING_KIND = 0x10, SEF_SUBTREE_KIND = 0x20, SEF_KIND_MASK = (SEF_SETTING_KIND | SEF_SUBTREE_KIND) }
| Flags for SettingEntry. More...
enum | GameSettingsWidgets { SETTINGSEL_OPTIONSPANEL, SETTINGSEL_SCROLLBAR }
| Widget numbers of settings window. More...
enum | CustomCurrencyWidgets { CUSTCURR_RATE_DOWN, CUSTCURR_RATE_UP, CUSTCURR_RATE, CUSTCURR_SEPARATOR_EDIT, CUSTCURR_SEPARATOR, CUSTCURR_PREFIX_EDIT, CUSTCURR_PREFIX, CUSTCURR_SUFFIX_EDIT, CUSTCURR_SUFFIX, CUSTCURR_YEAR_DOWN, CUSTCURR_YEAR_UP, CUSTCURR_YEAR, CUSTCURR_PREVIEW }
| Widget numbers of the custom currency window. More...
## Functions
static StringID * | BuildDynamicDropdown (StringID base, int num)
void | InitGRFTownGeneratorNames ()
static StringID | TownName (int town_name)
static int | GetCurRes ()
static void | ShowTownnameDropdown (Window *w, int sel)
| Update/redraw the townnames dropdown.
static void | ShowCustCurrency ()
template<class T >
static void | ShowSetMenu (Window *w, int widget)
void | ShowGameOptions ()
void | StartupEconomy ()
void | SetDifficultyLevel (int mode, DifficultySettings *gm_opt)
static NWidgetBase * | MakeDifficultyOptionsWidgets (int *biggest_index)
void | ShowGameDifficulty ()
static const void * | ResolveVariableAddress (const GameSettings *settings_ptr, const SettingDesc *sd)
void | ShowGameSettings ()
void | DrawArrowButtons (int x, int y, Colours button_colour, byte state, bool clickable_left, bool clickable_right)
| Draw [<][>] boxes.
## Variables
static const StringID | _units_dropdown []
static const StringID | _driveside_dropdown []
static const StringID | _autosave_dropdown []
int | _nb_orig_names = SPECSTR_TOWNNAME_LAST - SPECSTR_TOWNNAME_START + 1
static StringID * | _grf_names = NULL
static int | _nb_grf_names = 0
static const NWidgetPart | _nested_game_options_widgets []
static const WindowDesc | _game_options_desc (WDP_CENTER, 0, 0, WC_GAME_OPTIONS, WC_NONE, WDF_UNCLICK_BUTTONS, _nested_game_options_widgets, lengthof(_nested_game_options_widgets))
static const NWidgetPart | _nested_game_difficulty_widgets []
| Widget definition for the game difficulty settings window.
static const WindowDesc | _game_difficulty_desc (WDP_CENTER, 0, 0, WC_GAME_OPTIONS, WC_NONE, WDF_UNCLICK_BUTTONS, _nested_game_difficulty_widgets, lengthof(_nested_game_difficulty_widgets))
| Window definition for the game difficulty settings window.
static int | SETTING_HEIGHT = 11
| Height of a single setting in the tree view in pixels.
static const int | LEVEL_WIDTH = 15
| Indenting width of a sub-page in pixels.
static SettingEntry | _settings_ui_display []
static SettingsPage | _settings_ui_display_page = {_settings_ui_display, lengthof(_settings_ui_display)}
| Display options sub-page.
static SettingEntry | _settings_ui_interaction []
static SettingsPage | _settings_ui_interaction_page = {_settings_ui_interaction, lengthof(_settings_ui_interaction)}
| Interaction sub-page.
static SettingEntry | _settings_ui []
static SettingsPage | _settings_ui_page = {_settings_ui, lengthof(_settings_ui)}
| Interface subpage.
static SettingEntry | _settings_construction_signals []
static SettingsPage | _settings_construction_signals_page = {_settings_construction_signals, lengthof(_settings_construction_signals)}
| Signals subpage.
static SettingEntry | _settings_construction []
static SettingsPage | _settings_construction_page = {_settings_construction, lengthof(_settings_construction)}
| Construction sub-page.
static SettingEntry | _settings_stations_cargo []
static SettingsPage | _settings_stations_cargo_page = {_settings_stations_cargo, lengthof(_settings_stations_cargo)}
| Cargo handling sub-page.
static SettingEntry | _settings_stations []
static SettingsPage | _settings_stations_page = {_settings_stations, lengthof(_settings_stations)}
| Stations sub-page.
static SettingEntry | _settings_economy_towns []
static SettingsPage | _settings_economy_towns_page = {_settings_economy_towns, lengthof(_settings_economy_towns)}
| Towns sub-page.
static SettingEntry | _settings_economy_industries []
static SettingsPage | _settings_economy_industries_page = {_settings_economy_industries, lengthof(_settings_economy_industries)}
| Industries sub-page.
static SettingEntry | _settings_economy []
static SettingsPage | _settings_economy_page = {_settings_economy, lengthof(_settings_economy)}
| Economy sub-page.
static SettingEntry | _settings_ai_npc []
static SettingsPage | _settings_ai_npc_page = {_settings_ai_npc, lengthof(_settings_ai_npc)}
| Computer players sub-page.
static SettingEntry | _settings_ai []
static SettingsPage | _settings_ai_page = {_settings_ai, lengthof(_settings_ai)}
| AI sub-page.
static SettingEntry | _settings_vehicles_routing []
static SettingsPage | _settings_vehicles_routing_page = {_settings_vehicles_routing, lengthof(_settings_vehicles_routing)}
| Autorenew sub-page.
static SettingEntry | _settings_vehicles_autorenew []
static SettingsPage | _settings_vehicles_autorenew_page = {_settings_vehicles_autorenew, lengthof(_settings_vehicles_autorenew)}
| Autorenew sub-page.
static SettingEntry | _settings_vehicles_servicing []
static SettingsPage | _settings_vehicles_servicing_page = {_settings_vehicles_servicing, lengthof(_settings_vehicles_servicing)}
| Servicing sub-page.
static SettingEntry | _settings_vehicles_trains []
static SettingsPage | _settings_vehicles_trains_page = {_settings_vehicles_trains, lengthof(_settings_vehicles_trains)}
| Trains sub-page.
static SettingEntry | _settings_vehicles []
static SettingsPage | _settings_vehicles_page = {_settings_vehicles, lengthof(_settings_vehicles)}
| Vehicles sub-page.
static SettingEntry | _settings_main []
static SettingsPage | _settings_main_page = {_settings_main, lengthof(_settings_main)}
| Main page, holding all advanced settings.
static const NWidgetPart | _nested_settings_selection_widgets []
static const WindowDesc | _settings_selection_desc (WDP_CENTER, 450, 397, WC_GAME_OPTIONS, WC_NONE, 0, _nested_settings_selection_widgets, lengthof(_nested_settings_selection_widgets))
static const NWidgetPart | _nested_cust_currency_widgets []
static const WindowDesc | _cust_currency_desc (WDP_CENTER, 0, 0, WC_CUSTOM_CURRENCY, WC_NONE, WDF_UNCLICK_BUTTONS, _nested_cust_currency_widgets, lengthof(_nested_cust_currency_widgets))

## Detailed Description

GUI for settings.

Definition in file settings_gui.cpp.

## Enumeration Type Documentation

enum CustomCurrencyWidgets

Widget numbers of the custom currency window.

Definition at line 1757 of file settings_gui.cpp.

enum GameOptionsWidgets

Widgets of the game options menu.

Enumerator:

  GOW_BACKGROUND | Background of the window.
  GOW_CURRENCY_DROPDOWN | Currency dropdown.
  GOW_DISTANCE_DROPDOWN | Measuring unit dropdown.
  GOW_ROADSIDE_DROPDOWN | Dropdown to select the road side (to set the right side ;)).
  GOW_TOWNNAME_DROPDOWN | Town name dropdown.
  GOW_AUTOSAVE_DROPDOWN | Dropdown to say how often to autosave.
  GOW_LANG_DROPDOWN | Language dropdown.
  GOW_RESOLUTION_DROPDOWN | Dropdown for the resolution.
  GOW_FULLSCREEN_BUTTON | Toggle fullscreen.
  GOW_SCREENSHOT_DROPDOWN | Select the screenshot type... please use PNG!
  GOW_BASE_GRF_DROPDOWN | Use to select a base GRF.
  GOW_BASE_GRF_STATUS | Info about missing files etc.
  GOW_BASE_GRF_DESCRIPTION | Description of selected base GRF.
  GOW_BASE_SFX_DROPDOWN | Use to select a base SFX.
  GOW_BASE_SFX_DESCRIPTION | Description of selected base SFX.
  GOW_BASE_MUSIC_DROPDOWN | Use to select a base music set.
  GOW_BASE_MUSIC_STATUS | Info about corrupted files etc.
  GOW_BASE_MUSIC_DESCRIPTION | Description of selected base music set.

Definition at line 105 of file settings_gui.cpp.

enum GameSettingsWidgets

Widget numbers of settings window.

Enumerator:

  SETTINGSEL_OPTIONSPANEL | Panel widget containing the option lists.
  SETTINGSEL_SCROLLBAR | Scrollbar.

Definition at line 1485 of file settings_gui.cpp.

enum SettingEntryFlags

Flags for SettingEntry.

Note:
  The SEF_BUTTONS_MASK matches expectations of the formal parameter 'state' of DrawArrowButtons

Enumerator:

  SEF_LEFT_DEPRESSED | Of a numeric setting entry, the left button is depressed.
  SEF_RIGHT_DEPRESSED | Of a numeric setting entry, the right button is depressed.
  SEF_BUTTONS_MASK | Bit-mask for button flags.
  SEF_LAST_FIELD | This entry is the last one in a (sub-)page.
  SEF_SETTING_KIND | Entry kind: Entry is a setting.
  SEF_SUBTREE_KIND | Entry kind: Entry is a sub-tree.
  SEF_KIND_MASK | Bit-mask for fetching entry kind.

Definition at line 828 of file settings_gui.cpp.

## Function Documentation

void DrawArrowButtons | ( | int | x,
|  | int | y,
|  | Colours | button_colour,
|  | byte | state,
|  | bool | clickable_left,
|  | bool | clickable_right |
| ) |  |  |

Draw [<][>] boxes.

Parameters:

  | x | the x position to draw
  | y | the y position to draw
  | button_colour | the colour of the button
  | state | 0 = none clicked, 1 = first clicked, 2 = second clicked
  | clickable_left | is the left button clickable?
  | clickable_right | is the right button clickable?

Definition at line 1737 of file settings_gui.cpp.

References _colour_gradient, _dynlang, DrawFrameRect(), DrawSprite(), FILLRECT_CHECKER, FR_LOWERED, GfxFillRect(), TD_RTL, DynamicLanguages::text_dir, WD_IMGBTN_LEFT, and WD_IMGBTN_TOP.

Referenced by IndustryViewWindow::DrawInfo(), SettingEntry::DrawSetting(), CheatWindow::DrawWidget(), and AISettingsWindow::DrawWidget().

static void ShowTownnameDropdown | ( | Window * | w,
|  | int | sel |
| ) |  |  | `[static]`

Update/redraw the townnames dropdown.

Parameters:

  | w | the window the dropdown belongs to
  | sel | the currently selected townname generator

Definition at line 131 of file settings_gui.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tcache, Tzero >::PoolItem<&_town_pool >::GetNumItems(), GOW_TOWNNAME_DROPDOWN, and ShowDropDownList().

Referenced by GameOptionsWindow::OnClick().

## Variable Documentation

const StringID _autosave_dropdown[]`[static]`

Initial value:

     {
      STR_GAME_OPTIONS_AUTOSAVE_DROPDOWN_OFF,
      STR_GAME_OPTIONS_AUTOSAVE_DROPDOWN_EVERY_1_MONTH,
      STR_GAME_OPTIONS_AUTOSAVE_DROPDOWN_EVERY_3_MONTHS,
      STR_GAME_OPTIONS_AUTOSAVE_DROPDOWN_EVERY_6_MONTHS,
      STR_GAME_OPTIONS_AUTOSAVE_DROPDOWN_EVERY_12_MONTHS,
      INVALID_STRING_ID,
    }

Definition at line 53 of file settings_gui.cpp.

const StringID _driveside_dropdown[]`[static]`

Initial value:

     {
      STR_GAME_OPTIONS_ROAD_VEHICLES_DROPDOWN_LEFT,
      STR_GAME_OPTIONS_ROAD_VEHICLES_DROPDOWN_RIGHT,
      INVALID_STRING_ID
    }

Definition at line 47 of file settings_gui.cpp.

const NWidgetPart _nested_settings_selection_widgets[]`[static]`

Initial value:

     {
      NWidget(NWID_HORIZONTAL),
        NWidget(WWT_CLOSEBOX, COLOUR_MAUVE),
        NWidget(WWT_CAPTION, COLOUR_MAUVE), SetDataTip(STR_CONFIG_SETTING_CAPTION, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
      EndContainer(),
      NWidget(NWID_HORIZONTAL),
        NWidget(WWT_PANEL, COLOUR_MAUVE, SETTINGSEL_OPTIONSPANEL), SetMinimalSize(400, 174), EndContainer(),
        NWidget(NWID_VERTICAL),
          NWidget(WWT_SCROLLBAR, COLOUR_MAUVE, SETTINGSEL_SCROLLBAR),
          NWidget(WWT_RESIZEBOX, COLOUR_MAUVE),
        EndContainer(),
      EndContainer(),
    }

Definition at line 1700 of file settings_gui.cpp.

SettingEntry _settings_ai[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_ai_npc_page, STR_CONFIG_SETTING_AI_NPC),
      SettingEntry("economy.give_money"),
      SettingEntry("economy.allow_shares"),
    }

Definition at line 1399 of file settings_gui.cpp.

SettingEntry _settings_ai_npc[]`[static]`

Initial value:

     {
      SettingEntry("ai.ai_in_multiplayer"),
      SettingEntry("ai.ai_disable_veh_train"),
      SettingEntry("ai.ai_disable_veh_roadveh"),
      SettingEntry("ai.ai_disable_veh_aircraft"),
      SettingEntry("ai.ai_disable_veh_ship"),
      SettingEntry("ai.ai_max_opcode_till_suspend"),
    }

Definition at line 1388 of file settings_gui.cpp.

SettingEntry _settings_construction[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_construction_signals_page, STR_CONFIG_SETTING_CONSTRUCTION_SIGNALS),
      SettingEntry("construction.build_on_slopes"),
      SettingEntry("construction.autoslope"),
      SettingEntry("construction.extra_dynamite"),
      SettingEntry("construction.longbridges"),
      SettingEntry("station.never_expire_airports"),
      SettingEntry("construction.freeform_edges"),
      SettingEntry("construction.extra_tree_placement"),
    }

Definition at line 1319 of file settings_gui.cpp.

SettingEntry _settings_construction_signals[]`[static]`

Initial value:

     {
      SettingEntry("construction.signal_side"),
      SettingEntry("gui.enable_signal_gui"),
      SettingEntry("gui.drag_signals_density"),
      SettingEntry("gui.semaphore_build_before"),
      SettingEntry("gui.default_signal_type"),
      SettingEntry("gui.cycle_signal_types"),
    }

Definition at line 1308 of file settings_gui.cpp.

SettingEntry _settings_economy[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_economy_towns_page, STR_CONFIG_SETTING_ECONOMY_TOWNS),
      SettingEntry(&_settings_economy_industries_page, STR_CONFIG_SETTING_ECONOMY_INDUSTRIES),
      SettingEntry("economy.inflation"),
      SettingEntry("economy.smooth_economy"),
      SettingEntry("economy.feeder_payment_share"),
    }

Definition at line 1378 of file settings_gui.cpp.

SettingEntry _settings_economy_industries[]`[static]`

Initial value:

     {
      SettingEntry("construction.raw_industry_construction"),
      SettingEntry("economy.multiple_industry_per_town"),
      SettingEntry("economy.same_industry_close"),
      SettingEntry("game_creation.oil_refinery_limit"),
    }

Definition at line 1369 of file settings_gui.cpp.

SettingEntry _settings_economy_towns[]`[static]`

Initial value:

     {
      SettingEntry("economy.bribe"),
      SettingEntry("economy.exclusive_rights"),
      SettingEntry("economy.town_layout"),
      SettingEntry("economy.allow_town_roads"),
      SettingEntry("economy.found_town"),
      SettingEntry("economy.mod_road_rebuild"),
      SettingEntry("economy.town_growth_rate"),
      SettingEntry("economy.larger_towns"),
      SettingEntry("economy.initial_city_size"),
    }

Definition at line 1355 of file settings_gui.cpp.

SettingEntry _settings_main[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_ui_page,           STR_CONFIG_SETTING_GUI),
      SettingEntry(&_settings_construction_page, STR_CONFIG_SETTING_CONSTRUCTION),
      SettingEntry(&_settings_vehicles_page,     STR_CONFIG_SETTING_VEHICLES),
      SettingEntry(&_settings_stations_page,     STR_CONFIG_SETTING_STATIONS),
      SettingEntry(&_settings_economy_page,      STR_CONFIG_SETTING_ECONOMY),
      SettingEntry(&_settings_ai_page,           STR_CONFIG_SETTING_AI),
    }

Definition at line 1472 of file settings_gui.cpp.

SettingEntry _settings_stations[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_stations_cargo_page, STR_CONFIG_SETTING_STATIONS_CARGOHANDLING),
      SettingEntry("station.join_stations"),
      SettingEntry("station.nonuniform_stations"),
      SettingEntry("station.adjacent_stations"),
      SettingEntry("station.distant_join_stations"),
      SettingEntry("station.station_spread"),
      SettingEntry("economy.station_noise_level"),
      SettingEntry("station.modified_catchment"),
      SettingEntry("construction.road_stop_on_town_road"),
      SettingEntry("construction.road_stop_on_competitor_road"),
    }

Definition at line 1340 of file settings_gui.cpp.

SettingEntry _settings_stations_cargo[]`[static]`

Initial value:

     {
      SettingEntry("order.improved_load"),
      SettingEntry("order.gradual_loading"),
      SettingEntry("order.selectgoods"),
    }

Definition at line 1332 of file settings_gui.cpp.

SettingEntry _settings_ui[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_ui_display_page, STR_CONFIG_SETTING_DISPLAY_OPTIONS),
      SettingEntry(&_settings_ui_interaction_page, STR_CONFIG_SETTING_INTERACTION),
      SettingEntry("gui.show_finances"),
      SettingEntry("gui.errmsg_duration"),
      SettingEntry("gui.toolbar_pos"),
      SettingEntry("gui.pause_on_newgame"),
      SettingEntry("gui.advanced_vehicle_list"),
      SettingEntry("gui.timetable_in_ticks"),
      SettingEntry("gui.timetable_arrival_departure"),
      SettingEntry("gui.quick_goto"),
      SettingEntry("gui.default_rail_type"),
      SettingEntry("gui.always_build_infrastructure"),
      SettingEntry("gui.persistent_buildingtools"),
      SettingEntry("gui.coloured_news_year"),
    }

Definition at line 1289 of file settings_gui.cpp.

SettingEntry _settings_ui_display[]`[static]`

Initial value:

     {
      SettingEntry("gui.vehicle_speed"),
      SettingEntry("gui.status_long_date"),
      SettingEntry("gui.date_format_in_default_names"),
      SettingEntry("gui.population_in_label"),
      SettingEntry("gui.measure_tooltip"),
      SettingEntry("gui.loading_indicators"),
      SettingEntry("gui.liveries"),
      SettingEntry("gui.show_track_reservation"),
      SettingEntry("gui.expenses_layout"),
      SettingEntry("gui.smallmap_land_colour"),
    }

Definition at line 1252 of file settings_gui.cpp.

SettingEntry _settings_ui_interaction[]`[static]`

Initial value:

     {
      SettingEntry("gui.window_snap_radius"),
      SettingEntry("gui.window_soft_limit"),
      SettingEntry("gui.link_terraform_toolbar"),
      SettingEntry("gui.prefer_teamchat"),
      SettingEntry("gui.autoscroll"),
      SettingEntry("gui.reverse_scroll"),
      SettingEntry("gui.smooth_scroll"),
      SettingEntry("gui.left_mouse_btn_scrolling"),

      SettingEntry("gui.scrollwheel_scrolling"),
      SettingEntry("gui.scrollwheel_multiplier"),

    }

Definition at line 1267 of file settings_gui.cpp.

SettingEntry _settings_vehicles[]`[static]`

Initial value:

     {
      SettingEntry(&_settings_vehicles_routing_page, STR_CONFIG_SETTING_VEHICLES_ROUTING),
      SettingEntry(&_settings_vehicles_autorenew_page, STR_CONFIG_SETTING_VEHICLES_AUTORENEW),
      SettingEntry(&_settings_vehicles_servicing_page, STR_CONFIG_SETTING_VEHICLES_SERVICING),
      SettingEntry(&_settings_vehicles_trains_page, STR_CONFIG_SETTING_VEHICLES_TRAINS),
      SettingEntry("order.gotodepot"),
      SettingEntry("gui.new_nonstop"),
      SettingEntry("gui.order_review_system"),
      SettingEntry("gui.vehicle_income_warn"),
      SettingEntry("vehicle.never_expire_vehicles"),
      SettingEntry("vehicle.max_trains"),
      SettingEntry("vehicle.max_roadveh"),
      SettingEntry("vehicle.max_aircraft"),
      SettingEntry("vehicle.max_ships"),
      SettingEntry("vehicle.plane_speed"),
      SettingEntry("vehicle.plane_crashes"),
      SettingEntry("order.timetabling"),
      SettingEntry("vehicle.dynamic_engines"),
    }

Definition at line 1450 of file settings_gui.cpp.

SettingEntry _settings_vehicles_autorenew[]`[static]`

Initial value:

     {
      SettingEntry("company.engine_renew"),
      SettingEntry("company.engine_renew_months"),
      SettingEntry("company.engine_renew_money"),
    }

Definition at line 1417 of file settings_gui.cpp.

SettingEntry _settings_vehicles_routing[]`[static]`

Initial value:

     {
      SettingEntry("pf.pathfinder_for_trains"),
      SettingEntry("pf.forbid_90_deg"),
      SettingEntry("pf.pathfinder_for_roadvehs"),
      SettingEntry("pf.roadveh_queue"),
      SettingEntry("pf.pathfinder_for_ships"),
    }

Definition at line 1407 of file settings_gui.cpp.

SettingEntry _settings_vehicles_servicing[]`[static]`

Initial value:

     {
      SettingEntry("vehicle.servint_ispercent"),
      SettingEntry("vehicle.servint_trains"),
      SettingEntry("vehicle.servint_roadveh"),
      SettingEntry("vehicle.servint_ships"),
      SettingEntry("vehicle.servint_aircraft"),
      SettingEntry("order.no_servicing_if_no_breakdowns"),
      SettingEntry("order.serviceathelipad"),
    }

Definition at line 1425 of file settings_gui.cpp.

SettingEntry _settings_vehicles_trains[]`[static]`

Initial value:

     {
      SettingEntry("vehicle.train_acceleration_model"),
      SettingEntry("vehicle.train_slope_steepness"),
      SettingEntry("vehicle.mammoth_trains"),
      SettingEntry("gui.lost_train_warn"),
      SettingEntry("vehicle.wagon_speed_limits"),
      SettingEntry("vehicle.disable_elrails"),
      SettingEntry("vehicle.freight_trains"),
      SettingEntry("gui.stop_location"),
    }

Definition at line 1437 of file settings_gui.cpp.

const StringID _units_dropdown[]`[static]`

Initial value:

     {
      STR_GAME_OPTIONS_MEASURING_UNITS_IMPERIAL,
      STR_GAME_OPTIONS_MEASURING_UNITS_METRIC,
      STR_GAME_OPTIONS_MEASURING_UNITS_SI,
      INVALID_STRING_ID
    }

Definition at line 40 of file settings_gui.cpp.